## wvstreams 3.70

=== Makefile ===
TOPDIR=.

DEBUG=0
PREFIX=/usr/local
LIBDIR=${PREFIX}/lib
INCDIR=${PREFIX}/include/wvstreams
MANDIR=${PREFIX}/share/man

RELEASE=$(shell cat wvver.h \
	| awk '/\#define[ 	][ 	]*WVSTREAMS_VER[ 	]/ { print $$3 }' \
	| sed -e 's,0x\(....\)\(....\),\1.\2,' \
		-e 's/^0*//' \
		-e 's,\([^._]\)0*$$,\1,' )

export RELEASE

export TOPDIR DEBUG PREFIX LIBDIR INCDIR MANDIR

CC=${CXX}
CXXOPTS += -D_REENTRANT 
CXXOPTS-LIB=-fPIC

export CC CXX CXXOPTS

include $(TOPDIR)/wvrules.mk

SUBDIRS=src

all: $(SUBDIRS)

genkdoc:
	kdoc -f html -d doc --name wvstreams --strip-h-path src/*/*.h

doxygen:
	doxygen

install:
	$(subdirs)

installdev:
	$(subdirs)

installshared:
	$(subdirs)

uninstall:
	$(subdirs)

clean:
	$(subdirs)

=== src/Makefile ===
TOPDIR=.

-include $(TOPDIR)/wvrules.mk

SUBDIRS=utils streams configfile ipstreams crypto

INCFILES=$(wildcard include/*.h)
INCOUT=$(shell find . -type f -name '*.h' -printf "${INCDIR}/%f\n")
LIBFILES-DEV=libwvutils.a libwvstreams.a libwvcrypto.a
LIBFILES=libwvutils.so libwvstreams.so libwvcrypto.so

RELEASE=$(shell cat ../wvver.h \
	| awk '/\#define[ 	][ 	]*WVSTREAMS_VER[ 	]/ { print $$3 }' \
	| sed -e 's,0x\(....\)\(....\),\1.\2,' \
		-e 's/^0*//' \
		-e 's,\([^._]\)0*$$,\1,' )

export RELEASE

all: include $(SUBDIRS) libwvutils.a libwvutils.so \
	libwvstreams.a libwvstreams.so libwvcrypto.so libwvcrypto.a

include:
	rm -rf $@   
	mkdir $@.new
	cd $@.new && for d in $(SUBDIRS); do ln -s ../$$d/*.h .; done
	mv $@.new $@

libwvutils.so-LDFLAGS= -Wl,-soname,libwvutils.so.$(RELEASE)
libwvutils.so-LIBS=-lz -lcrypto
libwvutils.so: utils/utils.libs
libwvutils.a: utils/utils.libs

libwvstreams.so-LDFLAGS=-Wl,-soname,libwvstreams.so.$(RELEASE)
libwvstreams.so-LIBS=libwvutils.so
libwvstreams.so: ipstreams/ipstreams.libs
libwvstreams.a: ipstreams/ipstreams.libs

libwvcrypto.so-LDFLAGS=-Wl,-soname,libwvcrypto.so.$(RELEASE)
libwvcrypto.so-LIBS=libwvstreams.so -lssl -lcrypto
libwvcrypto.so: crypto/crypto.libs
libwvcrypto.a: crypto/crypto.libs

wvrules.mk:
	[ -e ../wvrules.mk ] && ln -s ../wvrules.mk .

install: installshared installdev

installshared: all
	[ -d ${LIBDIR}      ] || install -d ${LIBDIR}
	for d in ${LIBFILES}; do \
		strip --strip-unneeded $$d; \
		install -m 0644 $$d ${LIBDIR}/$$d.${RELEASE}; \
	done

installdev: all
	[ -d ${LIBDIR}      ] || install -d ${LIBDIR}
	[ -d ${INCDIR}      ] || install -d ${INCDIR}
	set -x; for d in ${INCFILES}; do \
		install -m 0644 $$d ${INCDIR}; \
	done
	for d in ${LIBFILES-DEV}; do \
		install -m 0644 $$d ${LIBDIR}; \
	done
	for d in ${LIBFILES}; do \
		( cd ${LIBDIR} ; ln -s $$d.${RELEASE} $$d ) ; \
	done

uninstall:
	cd ${LIBDIR}; rm -f ${LIBFILES}
	rm -f ${INCOUT}
	-rmdir ${INCDIR}

clean:
	$(subdirs)

=== src/Docs/Makefile ===
TOPDIR=..
include $(TOPDIR)/wvrules.mk

all: 

clean:
	$(MAKE) -C sgmlmanual clean

=== src/configfile/Makefile ===
TOPDIR=..
include $(TOPDIR)/wvrules.mk

XPATH=../utils ../streams

default: all initest delsection

all: configfile.libs

configfile.libs: wvconf.o cfgsection.o cfgentry.o ../streams/streams.libs

configfile.a: configfile.libs

#LIBS = ${EFENCE}

initest delsection: configfile.a

clean:
	rm -f initest delsection

=== src/crypto/Makefile ===
TOPDIR=..
include ${TOPDIR}/wvrules.mk

# if you compile SSLeay yourself, change this to the base directory of the
# package (e.g. /usr/src/SSLeay)
SSLDIR=SILLY/ssleay

# List of include directories for SSLeay.  If none of these is yours, add
# it to the list.
SSLINC= /usr/include/ssl /usr/include/ssleay /usr/local/include/ssl \
	/usr/local/ssl/include /usr/local/ssleay/include /usr/include/openssl

# List of library directories for SSLeay.  Add yours to the list.
# Don't forget the -L before each directory name!
SSLLIB= -L/usr/lib/ssl -L/usr/lib/ssleay -L/usr/local/lib/ssleay \
	-L/usr/local/ssl -L/usr/local/ssl/lib -L/usr/local/ssleay

default: all cryptotest ssltest sslsrvtest certtest reqtest md5test
all: crypto.libs

LIBS += -L${SSLDIR} ${SSLLIB} -lssl -lcrypto -L.. -lwvutils -lwvstreams
LIBS += ${EFENCE}

XPATH=.. ../utils ../streams ../configfile ../ipstreams \
	${SSLDIR}/include ${SSLINC}

crypto.libs: wvcrypto.o wvsslstream.o wvx509.o

crypto.a: crypto.libs

cryptotest ssltest sslsrvtest certtest reqtest md5test: crypto.a

clean:
	rm -f cryptotest ssltest sslsrvtest certtest reqtest md5test testcert.pem

=== src/hconf/Makefile ===
TOPDIR=..
include $(TOPDIR)/wvrules.mk

XPATH=../utils ../streams ../configfile

default: all hconftest

all: hconf.a

hconftest: hconftest.o hconf.a

hconf.libs: wvhconfkey.o wvhconf.o wvhconfgen.o \
	../streams/streams.libs ../utils/utils.libs

hconf.a: hconf.libs

LIBS = ${EFENCE}

clean:
	rm -f hconftest

=== src/ipstreams/Makefile ===
TOPDIR=..
include $(TOPDIR)/wvrules.mk

XPATH=.. ../utils ../streams

TESTS=tcptest udptest udp2test listentest unixtest ulistentest \
	resolvertest routetest \
	conttest aliastest simpleconn httptest

default: all $(TESTS)

all: ipstreams.libs

ipstreams.libs: wvaddr.o wvtcp.o wvudp.o wvresolver.o wvhttp.o wvinterface.o \
		wviproute.o wvipaliaser.o wvipfirewall.o wvunixsocket.o \
		../configfile/configfile.libs

ipstreams.a: ipstreams.libs

#LIBS=$(EFENCE)
tcptest udptest udp2test listentest unixtest ulistentest \
	resolvertest routetest \
	conttest aliastest simpleconn httptest simpleconn: \
		ipstreams.a

clean:
	rm -f $(TESTS)

=== src/streams/Makefile ===
TOPDIR=..
include $(TOPDIR)/wvrules.mk

# some crazy magic for WvLockFile to use the liblockdev library if it's
# available, or our simpler method otherwise.
#
#LOCKDEV = $(shell [ -f /usr/include/lockdev.h -a -f /usr/lib/liblockdev.a ] \
#		&& echo /usr/lib/liblockdev.a)
CFLAGS += $(shell [ -n "$(LOCKDEV)" ] && echo -DUSE_LOCKDEV=1 )

XPATH=.. ../utils ../zlib

#LIBS=$(EFENCE)

default: all watchtest pipetest clonetest modemtest logtest logbuftest  \
         syslogtest looptest timetest prototest

all: report-lock-mode streams.libs

# more crazy lockfile magic
#
.PHONY: report-lock-mode
report-lock-mode:
	@if [ -n "$(LOCKDEV)" ]; then \
		echo Using liblockdev.a for device locking in wvlockfile.; \
	else \
		echo Using my own device locking functions in wvlockfile.; \
	fi

streams.libs: wvstream.o wvstreamlist.o wvsplitstream.o wvstreamclone.o \
	wvfile.o wvlog.o wvlogbuffer.o wvsyslog.o wvwatcher.o wvpipe.o \
	wvloopback.o wvmodem.o wvtimestream.o wvprotostream.o \
	wvlockfile.o wvdailyevent.o $(LOCKDEV) ../utils/utils.libs

streams.a: streams.libs $(LOCKDEV)

watchtest pipetest clonetest modemtest logtest logbuftest syslogtest \
	looptest timetest prototest: streams.a

clean:
	rm -f watchtest pipetest clonetest modemtest logtest logbuftest \
              syslogtest looptest timetest prototest

=== src/utils/Makefile ===
TOPDIR=..
include $(TOPDIR)/wvrules.mk

TESTS=teststr testlist testhash stresshash testbuffer testbase64 testver \
		testtask testsort testproc testfork testencoder testdiriter \
		testcallback

#ifeq($(OS),Linux)
  MODULES=base64.o verstring.o strutils.o strcrypt.o \
		wvstring.o wvstringlist.o wvstringtable.o \
		wvlinklist.o wvhashtable.o wvsorter.o wvbuffer.o wvtask.o \
		wvfork.o wvsubproc.o wvencoder.o wvgzip.o wvcrash.o \
		wvdiriter.o
#else
#  MODULES=base64.o verstring.o strutils.o strcrypt.o \
#		wvstring.o wvstringlist.o wvstringtable.o \
#		wvlinklist.o wvhashtable.o wvsorter.o wvbuffer.o wvtask.o \
#		wvfork.o wvsubproc.o wvencoder.o wvgzip.o \
#		wvdiriter.o
#endif

default: all $(TESTS)

all: utils.libs

testencoder-LIBS=-lz

utils.libs: $(MODULES)
utils.a: utils.libs

LIBS=${EFENCE}
$(TESTS): utils.a

clean:
	rm -f $(TESTS)

=== src/Docs/sgmlmanual/egfiles/Makefile ===
TOPDIR=../../..
STATIC=1
include $(TOPDIR)/wvrules.mk

LIBS=-L$(TOPDIR) -lwvcrypto -lwvstreams -lcrypto
XPATH=$(TOPDIR)/include

LD_LIBRARY_PATH+=:$(TOPDIR)
export LD_LIBRARY_PATH

PROGS = $(shell echo *.cc | sed 's/\.cc//g')

default: all

all: $(PROGS)

$(PROGS): $(XFILES)

clean:
	rm -f $(PROGS)

=== debian/changelog ===
wvstreams (3.70) unstable; urgency=high

  * Fix to WvPipe so that WvDial doesn't crash

  * Fix to WvString formatter to fix retchmail crasher

  * Various other fixes and cleanups. 

 -- Patrick Patterson <ppatters@debian.org>  Fri,  5 Apr 2002 13:39:21 -0500

wvstreams (3.69) unstable; urgency=low

  * Fix to make wvstreams compile without extra effort and environment
    variables

  * Fix to library includes to avoid linker problem

  * Patch from RedHat to make WvStreams 64 bit clean

  * Fix a buglet in WvLinkList that caused some breakage in WvDialConf

  * Debian Packaging Fixes

  * Initial Debian release (Closes: #134134)

 -- Patrick Patterson <ppatters@nit.ca>  Fri,  5 Apr 2002 13:39:11 -0500

libwvstreams3.60 (3.60f) unstable; urgency=low

  * Initial Release.

 -- Patrick Patterson <ppatters@nit.ca>  Tue,  9 Dec 1997 01:39:45 -0500

Local variables:
mode: debian-changelog
add-log-mailing-address: "ppatters@nit.ca"
End:

=== debian/control ===
Source: wvstreams
Section: main/libs
Priority: optional
Maintainer: Patrick Patterson <ppatters@debian.org>
Build-Depends: debhelper (>> 3.0.0), libssl-dev, zlib1g-dev
Build-Depends-Indep: doxygen, sp, jade, jadetex, docbook-book, docbook, docbook-dsssl
Standards-Version: 3.5.2

Package: libwvstreams3
Architecture: any
Depends: ${shlibs:Depends}
Description: C++ Network Communications Layer for Rapid Application Development.
 WvStreams is a library set that comprises a number of parts. Among them are
 WvIPStreams (WvTCPStream and WvUDPStream), WvStrings (yet another C++ String
 class), WvCrypto Streams (including a REALLY easy way to add SSL Support to
 applications), WvConf (a configuration file handler), WvLog (nice, simple
 handling of log files), and a whole host of other goodness. These are the
 base classes used to build programs such as the ever popular WvDial,
 TunnelVision, FastForward, KWvDial, retchmail, and many more yet to come ;) 
 .
 This package includes everything needed to run programs that use this library
 to compile it you need the libwvstreams-dev package.

Package: libwvstreams-dev
Architecture: any
Depends: libwvstreams3 (= ${Source-Version}), libc6-dev
Description: C++ Network Communications Layer (development files)
 WvStreams is a library set that comprises a number of parts. Among them are
 WvIPStreams (WvTCPStream and WvUDPStream), WvStrings (yet another C++ String
 class), WvCrypto Streams (including a REALLY easy way to add SSL Support to 
 applications), WvConf (a configuration file handler), WvLog (nice, simple   
 handling of log files), and a whole host of other goodness. 
 .
 This is the development package and it includes everything that is needed to
 compile a program that needs wvstreams.

Package: libwvstreams-doc
Architecture: all
Description: Documentation for libwvstreams
 WvStreams is a library set that comprises a number of parts. Among them are
 WvIPStreams (WvTCPStream and WvUDPStream), WvStrings (yet another C++ String
 class), WvCrypto Streams (including a REALLY easy way to add SSL Support to 
 applications), WvConf (a configuration file handler), WvLog (nice, simple   
 handling of log files), and a whole host of other goodness.
 .
 This package includes all the documentation available to program this library.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for WvStreams, using debhelper. 
#
# Re-worked completely by Patrick Patterson <ppatters@nit.ca>
# from a patch sent by Baruch Even <baruch@debian.org>

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

version=3.69
major=3
base=libwvstreams
# This is used the wvstreams makefile to set the .so links
export RELEASE=$(version)

PKG=`pwd`/debian/${base}${major}
PKGDEV=`pwd`/debian/${base}-dev
PKGDOC=`pwd`/debian/${base}-doc
DOCDIR=$(PKGDOC)/usr/share/doc/$(base)-doc

configure: configure-stamp
configure-stamp: 
	dh_testdir
        # Add here commands to configure the package.
       
	touch configure-stamp

build: build-stamp
build-stamp: configure-stamp
	dh_testdir

	$(MAKE) CXXOPTS="-fno-implement-inlines -fno-rtti -fno-exceptions"
	touch build-stamp

build-indep: build-stamp-indep
build-stamp-indep: configure-stamp
	dh_testdir

	$(MAKE) doxygen
	$(MAKE) -C src/Docs/sgmlmanual html ps pdf

	touch build-stamp-indep

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp build-stamp-indep configure-stamp

	# Add here commands to clean up after the build process.
	-$(MAKE) clean
	-$(MAKE) -C src/Docs/sgmlmanual clean
	-rm -rf src/include dox
	dh_clean


install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

        # Install library package
	$(MAKE) install PREFIX=$(PKG)/usr

	# Install development package
	$(MAKE) installdev PREFIX=$(PKGDEV)/usr

install-indep: build-indep

	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	# Install documents package
	install -d $(DOCDIR)
	install -d $(DOCDIR)/html-api
	install -d $(DOCDIR)/html-manual
	install -m644 dox/html/* $(DOCDIR)/html-api/
	install -m644 src/Docs/sgmlmanual/wvstreams.html/*.html \
		$(DOCDIR)/html-manual/
	install -m644 src/Docs/sgmlmanual/wvstreams.ps \
		src/Docs/sgmlmanual/wvstreams.pdf \
		$(DOCDIR)


# Build architecture-independent files here.
binary-indep: build-indep install-indep
	dh_testdir -i
	dh_testroot -i

	dh_installdocs -i
	dh_installchangelogs -i
	dh_link -i
	dh_strip -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i   
	dh_builddeb -i  

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir -a
	dh_testroot -a
#      dh_movefiles -a

#      dh_installdebconf -a
	dh_installdocs -a   
	dh_installexamples -a
#      dh_installmenu -a
	dh_installman -a 
	dh_installinfo -a
#      dh_undocumented -a
	dh_installchangelogs -a
	dh_link -a
	dh_strip -a
	dh_compress -a
	dh_fixperms -a
	dh_makeshlibs -a -V
	dh_installdeb -a   
#      dh_perl -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a   
	dh_builddeb -a  

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

## wvstreams 3.75.0

=== Makefile ===
WVSTREAMS=$(shell pwd)
include wvrules.mk

XPATH=include

include vars.mk

all: config.mk $(TARGETS)

%.so: SONAME=$@.$(RELEASE)

.PHONY: ChangeLog clean depend dust kdoc doxygen install install-shared install-dev uninstall tests dishes dist distclean realclean

# FIXME: little trick to ensure that the wvautoconf.h.in file is there
.PHONY: dist-hack-clean
dist-hack-clean:
	rm -f stamp-h.in

dist: dist-hack-clean configure distclean
	rm -rf autom4te.cache

runconfigure: config.mk include/wvautoconf.h

config.mk include/wvautoconf.h: configure config.mk.in include/wvautoconf.h.in
	$(error Please run the "configure" script)

# FIXME: there is some confusion here
ifdef WE_ARE_DIST
configure: configure.ac config.mk.in include/wvautoconf.h.in
	$(warning "$@" is old, please run "autoconf")

include/wvautoconf.h.in: configure.ac
	$(warning "$@" is old, please run "autoheader")
else
configure: configure.ac
	autoheader
	autoconf

include/wvautoconf.h.in:
	autoheader
endif

ChangeLog:
	rm -f ChangeLog ChangeLog.bak
	cvs2cl --utc

define wild_clean
	@list=`echo $(wildcard $(1))` ; test -z "$${list}" || sh -cx "rm -rf $${list}"
endef

realclean: distclean
	$(call wild_clean,$(REALCLEAN))


distclean: clean
	$(call wild_clean,$(DISTCLEAN))

clean: depend dust
	$(call wild_clean,$(TARGETS) $(GARBAGE) $(TESTS) $(shell find . -name '*.o' -o -name '*.moc'))

depend:
	$(call wild_clean,$(shell find . -name '.*.d'))

dust:
	$(call wild_clean,$(shell find . -name 'core' -o -name '*~' -o -name '.#*') $(wildcard *.d))

kdoc:
	kdoc -f html -d Docs/kdoc-html --name wvstreams --strip-h-path */*.h

doxygen:
	doxygen

install: install-shared install-dev
#FIXME: We need to install uniconfd somewhere.

install-shared: $(TARGETS_SO)
	$(INSTALL) -d $(DESTDIR)$(libdir)
	for i in $(TARGETS_SO); do \
	    $(INSTALL_PROGRAM) $$i.$(RELEASE) $(DESTDIR)$(libdir)/ ; \
	done

install-dev: $(TARGETS_SO) $(TARGETS_A)
	$(INSTALL) -d $(DESTDIR)$(includedir)/wvstreams
	$(INSTALL_DATA) $(wildcard include/*.h) $(DESTDIR)$(includedir)/wvstreams
	$(INSTALL) -d $(DESTDIR)$(libdir)
	for i in $(TARGETS_A); do \
	    $(INSTALL_DATA) $$i $(DESTDIR)$(libdir); \
	done
	for i in $(TARGETS_SO); do \
	    cd $(DESTDIR)$(libdir) && $(LN_S) $$i.$(RELEASE) $$i; \
	done

uninstall:
	$(tbd)

$(TESTS): libuniconf.so libwvstreams.so libwvutils.so
$(addsuffix .o,$(TESTS)):
tests: $(TESTS)

include $(wildcard */rules.mk */*/rules.mk) /dev/null

-include $(shell find . -name '.*.d') /dev/null

test: runconfigure wvtestmain
	$(VALGRIND) ./wvtestmain

wvtestmain: wvtestmain.o $(call objects, $(shell find -type d -name t)) \
	libwvstreams.so libwvutils.so

=== Docs/sgmlmanual/egfiles/Makefile ===
#Remember to set TOPDIR to a directory containing wvrules.mk!
ifeq ($(TOPDIR),)
TOPDIR=../../..
endif

STATIC=1
include $(TOPDIR)/wvrules.mk

LIBS=-L$(TOPDIR) -lwvstreams -lwvutils -lcrypto 
XPATH=$(TOPDIR)/include

LD_LIBRARY_PATH+=:$(TOPDIR)
export LD_LIBRARY_PATH

PROGS = $(shell echo *.cc | sed 's/\.cc//g')

default: all

all: $(PROGS)

$(PROGS): $(XFILES)

clean:
	rm -f $(PROGS)

## wvstreams 4.0.2

=== Makefile ===
WVSTREAMS=.
WVSTREAMS_SRC= # Clear WVSTREAMS_SRC so wvrules.mk uses its WVSTREAMS_foo
include wvrules.mk
override enable_efence=no

export WVSTREAMS

XPATH=include

include vars.mk

all: config.mk xplc $(TARGETS)

.PHONY: xplc xplc/clean install-xplc
xplc:
xplc/clean:
install-xplc:

ifeq ("$(build_xplc)", "yes")

xplc:
	$(MAKE) -C xplc

xplc/clean:
	$(MAKE) -C xplc clean

install-xplc: xplc
	$(INSTALL) -d $(DESTDIR)$(includedir)/wvstreams/xplc
	$(INSTALL_DATA) $(wildcard xplc/include/xplc/*.h) $(DESTDIR)$(includedir)/wvstreams/xplc
	$(INSTALL) -d $(DESTDIR)$(libdir)
	$(INSTALL_DATA) xplc/libxplc-cxx.a $(DESTDIR)$(libdir)

endif

%.so: SONAME=$@.$(RELEASE)

.PHONY: clean depend dust kdoc doxygen install install-shared install-dev install-xplc uninstall tests dishes dist distclean realclean test

# FIXME: little trick to ensure that the wvautoconf.h.in file is there
.PHONY: dist-hack-clean
dist-hack-clean:
	rm -f stamp-h.in

dist-hook: dist-hack-clean configure
	rm -rf autom4te.cache
	if test -d .xplc; then \
	    $(MAKE) -C .xplc clean patch; \
	    cp -Lpr .xplc/build/xplc .; \
	fi

runconfigure: config.mk include/wvautoconf.h

ifndef CONFIGURING
configure=$(error Please run the "configure" script)
else
configure:=
endif

config.mk: configure config.mk.in
	$(call configure)

include/wvautoconf.h: include/wvautoconf.h.in
	$(call configure)

# FIXME: there is some confusion here
ifdef WE_ARE_DIST
configure: configure.ac config.mk.in include/wvautoconf.h.in
	$(warning "$@" is old, please run "autoconf")

include/wvautoconf.h.in: configure.ac
	$(warning "$@" is old, please run "autoheader")
else
configure: configure.ac
	autoheader
	autoconf

include/wvautoconf.h.in:
	autoheader
endif

define wild_clean
	@list=`echo $(wildcard $(1))`; \
		test -z "$${list}" || sh -cx "rm -rf $${list}"
endef

realclean: distclean
	$(call wild_clean,$(REALCLEAN))


distclean: clean
	$(call wild_clean,$(DISTCLEAN))
	@rm -f pkgconfig/*.pc
	@rm -f .xplc

clean: depend dust xplc/clean
	$(call wild_clean,$(TARGETS) uniconf/daemon/uniconfd \
		$(GARBAGE) $(TESTS) tmp.ini \
		$(shell find . -name '*.o' -o -name '*.moc'))

depend:
	$(call wild_clean,$(shell find . -name '.*.d'))

dust:
	$(call wild_clean,$(shell find . -name 'core' -o -name '*~' -o -name '.#*') $(wildcard *.d))

kdoc:
	kdoc -f html -d Docs/kdoc-html --name wvstreams --strip-h-path */*.h

doxygen:
	doxygen

install: install-shared install-dev install-xplc install-uniconfd

install-shared: $(TARGETS_SO)
	$(INSTALL) -d $(DESTDIR)$(libdir)
	for i in $(TARGETS_SO); do \
	    $(INSTALL_PROGRAM) $$i.$(RELEASE) $(DESTDIR)$(libdir)/ ; \
	done
	$(INSTALL) -d $(DESTDIR)$(sysconfdir)
	$(INSTALL_DATA) uniconf/daemon/uniconf.conf $(DESTDIR)$(sysconfdir)/

install-dev: $(TARGETS_SO) $(TARGETS_A)
	$(INSTALL) -d $(DESTDIR)$(includedir)/wvstreams
	$(INSTALL_DATA) $(wildcard include/*.h) $(DESTDIR)$(includedir)/wvstreams
	$(INSTALL) -d $(DESTDIR)$(libdir)
	for i in $(TARGETS_A); do \
	    $(INSTALL_DATA) $$i $(DESTDIR)$(libdir); \
	done
	cd $(DESTDIR)$(libdir) && for i in $(TARGETS_SO); do \
	    rm -f $$i; \
	    $(LN_S) $$i.$(RELEASE) $$i; \
	done
	$(INSTALL) -d $(DESTDIR)$(libdir)/pkgconfig
	$(INSTALL_DATA) $(wildcard pkgconfig/*.pc) $(DESTDIR)$(libdir)/pkgconfig

uniconfd: uniconf/daemon/uniconfd uniconf/daemon/uniconfd.ini \
          uniconf/daemon/uniconfd.8

install-uniconfd: uniconfd uniconf/tests/uni uniconf/tests/uni.8
	$(INSTALL) -d $(DESTDIR)$(bindir)
	$(INSTALL_PROGRAM) uniconf/tests/uni $(DESTDIR)$(bindir)/
	$(INSTALL) -d $(DESTDIR)$(sbindir)
	$(INSTALL_PROGRAM) uniconf/daemon/uniconfd $(DESTDIR)$(sbindir)/
	$(INSTALL) -d $(DESTDIR)$(localstatedir)/lib/uniconf
	touch $(DESTDIR)$(localstatedir)/lib/uniconf/uniconfd.ini
	$(INSTALL) -d $(DESTDIR)$(mandir)/man8
	$(INSTALL_DATA) uniconf/daemon/uniconfd.8 $(DESTDIR)$(mandir)/man8
	$(INSTALL_DATA) uniconf/tests/uni.8 $(DESTDIR)$(mandir)/man8

uninstall:
	$(tbd)

$(TESTS): $(LIBUNICONF)
$(addsuffix .o,$(TESTS)):
tests: $(TESTS)

include $(filter-out xplc%,$(wildcard */rules.mk */*/rules.mk)) /dev/null

-include $(shell find . -name '.*.d') /dev/null

test: runconfigure all tests wvtestmain
	LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$(WVSTREAMS_LIB)" $(WVTESTRUN) $(MAKE) runtests

runtests:
	$(VALGRIND) ./wvtestmain '$(TESTNAME)'
ifeq ("$(TESTNAME)", "unitest")
	cd uniconf/tests && DAEMON=0 ./unitest.sh
	cd uniconf/tests && DAEMON=1 ./unitest.sh
endif

wvtestmain: wvtestmain.o \
	$(call objects, $(shell find . -type d -name t)) \
	$(LIBUNICONF) $(LIBWVSTREAMS)

=== xplc/Makefile ===
# XPLC - Cross-Platform Lightweight Components
# Copyright (C) 2000, Pierre Phaneuf
# Copyright (C) 2002-2004, Net Integration Technologies, Inc.
#
# This library is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of the
# License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
# USA
#
# $Id: Makefile,v 1.13 2004/05/21 20:21:35 pphaneuf Exp $

.PHONY: default

default:

-include config/config.mk

CLEAN+=$(wildcard libxplc*.a libxplc.so.* doxygen)
DISTCLEAN+=config.cache config.log config.status dist/xplc.pc dist/xplc-uninstalled.pc xplc-uninstalled.pc
REALCLEAN+=configure README xplc.spec

include $(wildcard */vars.mk)

include $(wildcard */rules.mk)

=== xplc/tmp/Makefile ===

.PHONY: default
default: tstidl

IDL_CFLAGS=$(shell pkg-config --cflags libIDL-2.0)
IDL_LDFLAGS=$(shell pkg-config --libs libIDL-2.0)

tstidl: tstidl.c
	gcc $(IDL_CFLAGS) $(IDL_LDFLAGS) tstidl.c -o tstidl

=== xplc/examples/simple-module-user/Makefile ===
# This file is example code for XPLC (http://xplc.sourceforge.net/),
# and is put into the public domain.

.PHONY: default clean

# the UNSTABLE flag is there because we agree to use interfaces that
# have not been frozen yet.
CPPFLAGS+=-DUNSTABLE -I../simple-module $(shell pkg-config xplc-0.3.10 --cflags)
LDFLAGS+=$(shell pkg-config xplc-0.3.10 --libs-only-L)

default: example

clean:
	rm -f example *~ *.o

example: $(patsubst %.cpp,%.o,$(wildcard *.cpp))
	$(LINK.cc) $^ -lxplc -lxplc-cxx -o $@

$(wildcard *.o): $(wildcard *.h ../simple-module/*.h)

=== xplc/examples/simple-module/Makefile ===
# This file is example code for XPLC (http://xplc.sourceforge.net/),
# and is put into the public domain.

.PHONY: default clean

# the UNSTABLE flag is there because we agree to use interfaces that
# have not been frozen yet.
CPPFLAGS+=-DUNSTABLE $(shell pkg-config xplc-0.3.10 --cflags)
LDFLAGS+=$(shell pkg-config xplc-0.3.10 --libs-only-L)

default: example.so

clean:
	rm -f example.so *~ *.o

%.so:
	$(LINK.cc) -shared $^ -lxplc-cxx -o $@

example.so: $(patsubst %.cpp,%.o,$(wildcard *.cpp))

$(wildcard *.o): $(wildcard *.h)

## wvstreams 4.3

=== Makefile ===
--- 
+++ 
@@ -3,13 +3,19 @@
 include wvrules.mk
 override enable_efence=no
 
+ifneq (${_WIN32},)
+  $(error "Use 'make -f Makefile-win32' instead!")
+endif
+
 export WVSTREAMS
 
 XPATH=include
 
 include vars.mk
 
-all: config.mk xplc $(TARGETS)
+SUBDIRS = gnulib
+
+all: runconfigure xplc $(TARGETS)
 
 .PHONY: xplc xplc/clean install-xplc
 xplc:
@@ -32,23 +38,34 @@
 
 endif
 
-%.so: SONAME=$@.$(RELEASE)
-
 .PHONY: clean depend dust kdoc doxygen install install-shared install-dev install-xplc uninstall tests dishes dist distclean realclean test
 
 # FIXME: little trick to ensure that the wvautoconf.h.in file is there
 .PHONY: dist-hack-clean
 dist-hack-clean:
-	rm -f stamp-h.in
+	@rm -f stamp-h.in
+
+export AM_CFLAGS
+AM_CFLAGS=-fPIC
+gnulib/libgnu.a:
+	$(call subdirs_func,libgnu.a,gnulib)
+
+# Comment this assignment out for a release.
+ifdef PKGSNAPSHOT
+SNAPDATE=+$(shell date +%Y%m%d)
+endif
 
 dist-hook: dist-hack-clean configure
-	rm -rf autom4te.cache
-	if test -d .xplc; then \
-	    $(MAKE) -C .xplc clean patch; \
+	@rm -rf autom4te.cache
+	@if test -d .xplc; then \
+	    echo '--> Preparing XPLC for dist...'; \
+	    $(MAKE) -C .xplc clean patch && \
 	    cp -Lpr .xplc/build/xplc .; \
 	fi
-
-runconfigure: config.mk include/wvautoconf.h
+	@sed -e "s/@PKGVER@/$(PKGVER)$(SNAPDATE)/g" \
+	 redhat/wvstreams.spec.in > redhat/wvstreams.spec
+
+runconfigure: config.mk include/wvautoconf.h gnulib/Makefile
 
 ifndef CONFIGURING
 configure=$(error Please run the "configure" script)
@@ -62,26 +79,45 @@
 include/wvautoconf.h: include/wvautoconf.h.in
 	$(call configure)
 
+gnulib/Makefile: gnulib/Makefile.in
+	$(call configure)
+
 # FIXME: there is some confusion here
 ifdef WE_ARE_DIST
-configure: configure.ac config.mk.in include/wvautoconf.h.in
+aclocal.m4: $(wildcard gnulib/m4/*.m4) acinclude.m4
+	$(warning "$@" is old, please run "aclocal -I gnulib/m4")
+
+configure: configure.ac config.mk.in include/wvautoconf.h.in aclocal.m4
 	$(warning "$@" is old, please run "autoconf")
 
-include/wvautoconf.h.in: configure.ac
+include/wvautoconf.h.in: configure.ac aclocal.m4
 	$(warning "$@" is old, please run "autoheader")
 else
-configure: configure.ac
+aclocal.m4: $(wildcard gnulib/m4/*.m4) acinclude.m4
+	aclocal -I gnulib/m4
+	@touch $@
+
+configure: configure.ac include/wvautoconf.h.in aclocal.m4
+	autoconf
+	@rm -f config.mk include/wvautoconf.h gnulib/Makefile
+	@touch $@
+
+include/wvautoconf.h.in: configure.ac aclocal.m4
 	autoheader
-	autoconf
-
-include/wvautoconf.h.in:
-	autoheader
-endif
-
+	@touch $@
+endif
+
+ifeq ($(VERBOSE),)
+define wild_clean
+	@list=`echo $(wildcard $(1))`; \
+		test -z "$${list}" || sh -c "rm -rf $${list}"
+endef
+else
 define wild_clean
 	@list=`echo $(wildcard $(1))`; \
 		test -z "$${list}" || sh -cx "rm -rf $${list}"
 endef
+endif
 
 realclean: distclean
 	$(call wild_clean,$(REALCLEAN))
@@ -89,10 +125,15 @@
 
 distclean: clean
 	$(call wild_clean,$(DISTCLEAN))
+	@rm -rf autom4te.cache
+	@rm -f gnulib/Makefile
 	@rm -f pkgconfig/*.pc
 	@rm -f .xplc
 
 clean: depend dust xplc/clean
+	@if ! test -f gnulib/Makefile; then echo 'clean:' >gnulib/Makefile; fi
+	$(subdirs)
+	@if test `wc -c <gnulib/Makefile` = '7'; then rm gnulib/Makefile; fi
 	$(call wild_clean,$(TARGETS) uniconf/daemon/uniconfd \
 		$(GARBAGE) $(TESTS) tmp.ini \
 		$(shell find . -name '*.o' -o -name '*.moc'))
@@ -109,12 +150,16 @@
 doxygen:
 	doxygen
 
+ifeq ("$(with_readline)", "no")
 install: install-shared install-dev install-xplc install-uniconfd
+else
+install: install-shared install-dev install-xplc install-uniconfd install-wsd
+endif
 
 install-shared: $(TARGETS_SO)
 	$(INSTALL) -d $(DESTDIR)$(libdir)
 	for i in $(TARGETS_SO); do \
-	    $(INSTALL_PROGRAM) $$i.$(RELEASE) $(DESTDIR)$(libdir)/ ; \
+	    $(INSTALL_PROGRAM) $$i.$(SO_VERSION) $(DESTDIR)$(libdir)/ ; \
 	done
 	$(INSTALL) -d $(DESTDIR)$(sysconfdir)
 	$(INSTALL_DATA) uniconf/daemon/uniconf.conf $(DESTDIR)$(sysconfdir)/
@@ -128,10 +173,10 @@
 	done
 	cd $(DESTDIR)$(libdir) && for i in $(TARGETS_SO); do \
 	    rm -f $$i; \
-	    $(LN_S) $$i.$(RELEASE) $$i; \
+	    $(LN_S) $$i.$(SO_VERSION) $$i; \
 	done
 	$(INSTALL) -d $(DESTDIR)$(libdir)/pkgconfig
-	$(INSTALL_DATA) $(wildcard pkgconfig/*.pc) $(DESTDIR)$(libdir)/pkgconfig
+	$(INSTALL_DATA) $(filter-out %-uninstalled.pc, $(wildcard pkgconfig/*.pc)) $(DESTDIR)$(libdir)/pkgconfig
 
 uniconfd: uniconf/daemon/uniconfd uniconf/daemon/uniconfd.ini \
           uniconf/daemon/uniconfd.8
@@ -147,10 +192,14 @@
 	$(INSTALL_DATA) uniconf/daemon/uniconfd.8 $(DESTDIR)$(mandir)/man8
 	$(INSTALL_DATA) uniconf/tests/uni.8 $(DESTDIR)$(mandir)/man8
 
+install-wsd: ipstreams/tests/wsd
+	$(INSTALL) -d $(DESTDIR)$(bindir)
+	$(INSTALL_PROGRAM) ipstreams/tests/wsd $(DESTDIR)$(bindir)/
+
 uninstall:
 	$(tbd)
 
-$(TESTS): $(LIBUNICONF)
+$(TESTS): $(LIBUNICONF) $(LIBWVTEST)
 $(addsuffix .o,$(TESTS)):
 tests: $(TESTS)
 
@@ -158,8 +207,10 @@
 
 -include $(shell find . -name '.*.d') /dev/null
 
-test: runconfigure all tests wvtestmain
-	LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$(WVSTREAMS_LIB)" $(WVTESTRUN) $(MAKE) runtests
+test: runconfigure all tests qtest
+
+qtest: runconfigure all wvtestmain
+	LD_LIBRARY_PATH="$(LD_LIBRARY_PATH):$(WVSTREAMS_LIB)" $(WVTESTRUN) $(MAKE) runtests
 
 runtests:
 	$(VALGRIND) ./wvtestmain '$(TESTNAME)'
@@ -168,7 +219,8 @@
 	cd uniconf/tests && DAEMON=1 ./unitest.sh
 endif
 
-wvtestmain: wvtestmain.o \
-	$(call objects, $(shell find . -type d -name t)) \
-	$(LIBUNICONF) $(LIBWVSTREAMS)
-
+wvtestmain: \
+	$(call objects, $(filter-out ./Win32WvStreams/%, \
+		$(shell find . -type d -name t))) \
+	$(LIBUNICONF) $(LIBWVSTREAMS) $(LIBWVTEST)
+

## wvstreams 4.4.1

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,6 @@
 WVSTREAMS=.
 WVSTREAMS_SRC= # Clear WVSTREAMS_SRC so wvrules.mk uses its WVSTREAMS_foo
+VPATH=$(libdir)
 include wvrules.mk
 override enable_efence=no
 
@@ -62,8 +63,6 @@
 	    $(MAKE) -C .xplc clean patch && \
 	    cp -Lpr .xplc/build/xplc .; \
 	fi
-	@sed -e "s/@PKGVER@/$(PKGVER)$(SNAPDATE)/g" \
-	 redhat/wvstreams.spec.in > redhat/wvstreams.spec
 
 runconfigure: config.mk include/wvautoconf.h gnulib/Makefile
 
@@ -177,6 +176,10 @@
 	done
 	$(INSTALL) -d $(DESTDIR)$(libdir)/pkgconfig
 	$(INSTALL_DATA) $(filter-out %-uninstalled.pc, $(wildcard pkgconfig/*.pc)) $(DESTDIR)$(libdir)/pkgconfig
+	$(INSTALL) -d $(DESTDIR)$(bindir)
+	$(INSTALL) wvtesthelper wvtestmeter $(DESTDIR)$(bindir)
+	$(INSTALL) -d $(DESTDIR)$(libdir)/valgrind
+	$(INSTALL) wvstreams.supp $(DESTDIR)$(libdir)/valgrind
 
 uniconfd: uniconf/daemon/uniconfd uniconf/daemon/uniconfd.ini \
           uniconf/daemon/uniconfd.8

## wvstreams 4.6

=== Makefile ===
WVSTREAMS:=.

include wvrules.mk
include install.mk

ifdef _WIN32
    include win32.mk
endif

ifdef _SOLARIS
    RM = rm -f
    CFLAGS += -DSOLARIS
    CXXFLAGS += -DSOLARIS
else 
    ifdef _MACOS
    	CFLAGS+= -DMACOS
    	CXXFLAGS+= -DMACOS
    	WV_EXCLUDES+= linuxstreams/tests/aliastest linuxstreams/tests/ifctest linuxstreams/tests/routetest qt/tests/qtstringtest
    	TEST_SKIP_OBJS+= linuxstreams/t/%
    else
    	RM = rm -fv
    endif 
endif

%: %.subst
	sed -e 's/#VERSION#/$(WVPACKAGE_VERSION)/g' < $< > $@

ifeq ("$(enable_testgui)", "no")
  WVTESTRUN=env
endif

LIBS += -lm

ifeq ($(USE_WVSTREAMS_ARGP),1)
  utils/wvargs.o-CPPFLAGS += -Iargp
  libwvutils.so-LIBS += -Largp -largp

# argp does its own dependency checking, so let's call it once per wvstreams
# build, in case some system dependencies have changed and argp should be
# recompiled
  ARGP_TARGET=argp/libargp.list
  TARGETS += $(ARGP_TARGET)
.PHONY: argp/all
argp/all:
	$(MAKE) -C argp
# Warning!  Crucial!  KEEP THIS SEMICOLON HERE!  Without it, if you blow away
# $(ARGP_TARGET), $(MAKE) will get confused.
$(ARGP_TARGET): argp/all;
else
  ARGP_TARGET=
endif

#
# libwvbase: a the minimal code needed to link a wvstreams program.
#
BASEOBJS = \
	utils/wvbuffer.o utils/wvbufferstore.o \
	utils/wvcont.o \
	utils/wverror.o \
	streams/wvfdstream.o \
	utils/wvfork.o \
	utils/wvhash.o \
	utils/wvhashtable.o \
	utils/wvlinklist.o \
	utils/wvmoniker.o \
	utils/wvregex.o \
	utils/wvscatterhash.o utils/wvsorter.o \
	utils/wvattrs.o \
	utils/wvstring.o utils/wvstringlist.o \
	utils/wvstringmask.o \
	utils/strutils.o \
	utils/wvtask.o \
	utils/wvtimeutils.o \
	streams/wvistreamlist.o \
	utils/wvstreamsdebugger.o \
	streams/wvlog.o \
	streams/wvstream.o \
	uniconf/uniconf.o \
	uniconf/uniconfgen.o uniconf/uniconfkey.o uniconf/uniconfroot.o \
	uniconf/unihashtree.o \
	uniconf/unimountgen.o \
	uniconf/unitempgen.o \
	utils/wvbackslash.o \
	utils/wvencoder.o \
	utils/wvtclstring.o \
	utils/wvstringcache.o \
	uniconf/uniinigen.o \
	uniconf/unigenhack.o \
	uniconf/unilistiter.o \
	streams/wvfile.o \
	streams/wvstreamclone.o  \
	streams/wvconstream.o \
	utils/wvcrashbase.o \
	xplc-cxx/factory.o \
	xplc-cxx/getiface.o \
	xplc-cxx/strtouuid.o \
	xplc-cxx/uuidtostr.o \
	xplc-cxx/xplc.o \
	xplc/category.o \
	xplc/catiter.o \
	xplc/catmgr.o \
	xplc/loader.o \
	xplc/moduleloader.o \
	xplc/modulemgr.o \
	xplc/monikers.o \
	xplc/new.o \
	xplc/servmgr.o \
	xplc/statichandler.o 

TARGETS += libwvbase.so
libwvbase_OBJS += $(filter-out uniconf/unigenhack.o $(WV_EXCLUDES),$(BASEOBJS))
libwvbase.so: $(libwvbase_OBJS) uniconf/unigenhack.o
libwvbase.so-LIBS += $(LIBXPLC)

#
# libwvutils: handy utility library for C++
#
TARGETS += libwvutils.so
TESTS += $(call tests_cc,utils/tests)
libwvutils_OBJS += $(filter-out $(BASEOBJS) $(TESTOBJS),$(call objects,utils))
libwvutils.so: $(libwvutils_OBJS) $(LIBWVBASE) $(ARGP_TARGET)
ifndef _MACOS
libwvutils.so-LIBS += -lz -lcrypt $(LIBS_PAM)
else
libwvutils.so-LIBS += -lz $(LIBS_PAM)
endif

utils/tests/%: PRELIBS+=$(LIBWVSTREAMS)

#
# libwvstreams: stream/event handling library
#
TARGETS += libwvstreams.so
TARGETS += crypto/tests/ssltest ipstreams/tests/unixtest
TARGETS += crypto/tests/printcert

ifndef _MACOS
  ifneq ("$(with_readline)", "no")
    TARGETS += ipstreams/tests/wsd
    ipstreams/tests/wsd-LIBS += -lreadline
  else
    TEST_SKIP_OBJS += ipstreams/tests/wsd
  endif
else
  TEST_SKIP_OBJS += ipstreams/tests/wsd
endif

TESTS += $(call tests_cc,configfile/tests)
TESTS += $(call tests_cc,streams/tests)
TESTS += $(call tests_cc,ipstreams/tests)
TESTS += $(call tests_cc,crypto/tests)
TESTS += $(call tests_cc,urlget/tests)
TESTS += $(call tests_cc,linuxstreams/tests)
libwvstreams_OBJS += $(filter-out $(BASEOBJS), \
	$(call objects,configfile crypto ipstreams \
		$(ARCH_SUBDIRS) streams urlget))
libwvstreams.so: $(libwvstreams_OBJS) $(LIBWVUTILS)
libwvstreams.so-LIBS += -lz -lssl -lcrypto $(LIBS_PAM)
configfile/tests/% streams/tests/% ipstreams/tests/% crypto/tests/% \
  urlget/tests/% linuxstreams/tests/%: PRELIBS+=$(LIBWVSTREAMS)

#
# libuniconf: unified configuration system
#
TARGETS += libuniconf.so
TARGETS += uniconf/daemon/uniconfd uniconf/tests/uni
TESTS += $(call tests_cc,uniconf/tests) uniconf/tests/uni
libuniconf_OBJS += $(filter-out $(BASEOBJS) uniconf/daemon/uniconfd.o, \
	$(call objects,uniconf uniconf/daemon))
libuniconf.so: $(libuniconf_OBJS) $(LIBWVSTREAMS)
uniconf/daemon/uniconfd uniconf/tests/uni: $(LIBUNICONF)
uniconf/daemon/uniconfd: uniconf/daemon/uniconfd.o $(LIBUNICONF)
uniconf/daemon/uniconfd: uniconf/daemon/uniconfd.ini \
          uniconf/daemon/uniconfd.8
uniconf/tests/%: PRELIBS+=$(LIBUNICONF)

#
# libwvdbus: C++ DBus library based on wvstreams
#
ifneq ("$(with_dbus)", "no")
  TARGETS += libwvdbus.so
  TARGETS += dbus/tests/wvdbus dbus/tests/wvdbusd
  TESTS += $(call tests_cc,dbus/tests)
  libwvdbus_OBJS += $(call objects,dbus)
  libwvdbus.so: $(libwvdbus_OBJS) $(LIBWVSTREAMS)
  libwvdbus.so-LIBS += $(LIBS_DBUS)
  dbus/tests/%: PRELIBS+=$(LIBWVDBUS)
else
  TEST_SKIP_OBJS += dbus/t/%
endif

#
# libwvqt: helper library to make WvStreams work better in Qt event loops
#          This is not made to work with MacOS, so let's not ask it to.
ifndef _MACOS
ifneq ("$(with_qt)", "no")
  TARGETS += libwvqt.so
  TESTS += $(patsubst %.cc,%,$(wildcard qt/tests/*.cc))
  libwvqt_OBJS += $(call objects,qt)
  libwvqt.so: $(libwvqt_OBJS) $(LIBWVSTREAMS)
  libwvqt.so-LIBS += $(LIBS_QT)
  qt/tests/%: PRELIBS+=$(LIBWVQT)

  qt/wvqtstreamclone.o: include/wvqtstreamclone.moc
  qt/wvqthook.o: include/wvqthook.moc
endif
endif
#
# libwvstatic.a: all the wvstreams libraries in one static .a file, to make
# it easy to link your programs statically to wvstreams.
#
TARGETS += libwvstatic.a
libwvstatic.a: \
	$(libwvbase_OBJS) \
	$(libwvutils_OBJS) \
	$(libwvstreams_OBJS) \
	$(libuniconf_OBJS) \
	$(libwvdbus_OBJS) \
	$(libwvqt_OBJS) \
	uniconf/unigenhack_s.o \
	$(ARGP_TARGET)

#
# libwvtest: the WvTest tools for writing C++ unit tests
#
TARGETS += wvtestmain.o libwvtest.a
TESTOBJS = utils/wvtest.o
libwvtest.a: wvtestmain.o $(TESTOBJS)

TARGETS_SO = $(filter %.so,$(TARGETS))
TARGETS_A = $(filter %.a,$(TARGETS))

all: config.mk $(filter-out $(WV_EXCLUDES), $(TARGETS))

TESTS += wvtestmain

REAL_TESTS = $(filter-out $(TEST_SKIP_OBJS), $(TESTS))
$(addsuffix .o,$(REAL_TESTS)):
tests: $(REAL_TESTS)

test: all tests qtest

qtest: all wvtestmain
	LD_LIBRARY_PATH="$(LD_LIBRARY_PATH):$(shell pwd)" $(WVTESTRUN) $(MAKE) runtests

runtests:
	$(VALGRIND) ./wvtestmain '$(TESTNAME)'
ifeq ("$(TESTNAME)", "")
	cd uniconf/tests && DAEMON=0 ./unitest.sh
	cd uniconf/tests && DAEMON=1 ./unitest.sh
endif


TEST_TARGETS = 	$(filter-out $(TEST_SKIP_OBJS), $(call objects, $(filter-out win32/%, \
		$(shell find . -type d -name t | sed 's,^\./,,'))))

wvtestmain: $(TEST_TARGETS) $(LIBWVDBUS) $(LIBUNICONF) $(LIBWVSTREAMS) $(LIBWVTEST)

distclean: clean
	rm -f uniconf/daemon/uniconfd.8 uniconf/tests/uni
	rm -f config.mk config.log config.status \
		include/wvautoconf.h config.cache \
		stamp-h.in 
	rm -rf autom4te.cache
	rm -rf argp/autom4te.cache
	rm -rf argp/config.status argp/config.log
	rm -rf argp/configure.lineno argp/config.h
	rm -rf argp/Makefile argp/testsuite/Makefile
	rm -rf argp/testsuite/ex1 argp/testsuite/ex2 argp/testsuite/ex3
	rm -rf argp/libargp.a argp/stamp-h1
	rm -f pkgconfig/*.pc

clean:
	$(subdirs)
	@$(RM) .junk $(TARGETS) uniconf/daemon/uniconfd \
		$(TESTS) tmp*.ini uniconf/daemon/uniconfd.ini \
		.wvtest-total \
		$(shell find . -name '*.o' -o -name '.*.d' \
			-o -name '*~' -o -name '*.moc')
		
clean-targets:
	$(RM) $(TARGETS)
	
clean-tests:
	$(RM) $(TESTS)

kdoc:
	kdoc -f html -d Docs/kdoc-html --name wvstreams --strip-h-path */*.h

doxygen:
	doxygen

.PHONY: \
	clean distclean \
	kdoc doxygen \
	install install-shared install-dev uninstall \
	tests test

debug-make:
	@echo tests: $(TESTS)
	@echo real_tests: $(REAL_TESTS)
	@echo skip_tests: $(TEST_SKIP_OBJS)
	@echo excluded_items: $(WV_EXCLUDES)
	@echo targets: $(TARGETS)
